
/**********************************************************************
 * $Id: simUtils.h,v 1.3 93/02/09 16:44:52 drew Exp $
 **********************************************************************/

/**********************************************************************
 *   Copyright 1990,1991,1992,1993 by The University of Toronto,
 *		       Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute,  and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided  that the above copyright notice  appears in all copies and
 * that both the copyright notice and this permission notice  appear in
 * supporting documentation, and  that  the  name of The University  of
 * Toronto  not  be used  in advertising   or publicity pertaining   to
 * distribution  of   the software   without  specific, written   prior
 * permission.  The  University  of Toronto  makes   no representations
 * about the  suitability  of  this software  for  any purpose.   It is
 * provided "as is" without express or implied warranty.
 *
 * THE  UNIVERSITY OF  TORONTO DISCLAIMS ALL WARRANTIES  WITH REGARD TO
 * THIS SOFTWARE,  INCLUDING ALL  IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT  SHALL THE UNIVERSITY  OF TORONTO BE LIABLE
 * FOR ANY SPECIAL,  INDIRECT OR CONSEQUENTIAL  DAMAGES  OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF  USE, DATA OR PROFITS,  WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE  OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF OR  IN  CONNECTION   WITH  THE  USE OR  PERFORMANCE  OF THIS
 * SOFTWARE.
 *
 **********************************************************************/

#ifndef SIMUTILS_H
#define SIMUTILS_H

/***********************************************************************
 *	Standard masks, All of these are automatically registered
 ***********************************************************************/
#define SIM_ERR_UNKNOWN		0
#define SIM_ERR_MALLOC		1
#define SIM_ERR_BADARRAYSIZE	2

#define MAX_SIMERRNO	((int) (sizeof(simErrString)/sizeof(simErrString[0])))

extern int	simErrno ;
extern char	*simErrString[] ;

/***********************************************************************/

/***********************************************************************
 *	simulator utility functions
 ***********************************************************************/
#ifndef _SOURCE
extern void	simError ARGS((int num, char *format, ...)) ;
#endif /* _SOURCE */
extern double	simRand	ARGS(()) ;
extern void	simRandSeed ARGS((int seed)) ;
/***********************************************************************/

#endif				/* SIMUTILS_H */
