.CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
.C $Id: extract-commands.l,v 1.3 93/01/26 11:29:27 drew Exp $
.CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
.C
.CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
.C   Copyright 1990,1991,1992,1993 by The University of Toronto,
.C		      Toronto, Ontario, Canada.
.C 
.C			 All Rights Reserved
.C 
.C Permission to use, copy, modify, distribute, and sell this software
.C and  its documentation  for any   purpose is hereby granted without
.C fee, provided that the above copyright notice appears in all copies
.C and  that both  the  copyright  notice  and this permission  notice
.C appear in supporting documentation, and that the name of University
.C of Toronto not  be used in  advertising or publicity  pertaining to
.C distribution of   the   software   without specific, written  prior
.C permission.  University  of Toronto makes no representations  about
.C the suitability of  this software for any  purpose.  It is provided
.C "as is" without express or implied warranty.
.C
.C UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD  TO THIS
.C SOFTWARE, INCLUDING ALL  IMPLIED WARRANTIES  OF MERCHANTABILITY AND
.C FITNESS, IN NO EVENT SHALL UNIVERSITY  OF TORONTO BE LIABLE FOR ANY
.C SPECIAL,  INDIRECT  OR    CONSEQUENTIAL  DAMAGES OR     ANY DAMAGES
.C WHATSOEVER RESULTING FROM LOSS OF USE, DATA  OR PROFITS, WHETHER IN
.C AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
.C OUT  OF OR  IN CONNECTION  WITH  THE USE   OR  PERFORMANCE  OF THIS
.C SOFTWARE.
.C
.CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
.C
.de BF		\" boldface a word
\fI\\$1\fP
..
.de FT		\" start a field table with title
.PP
.nf
.ta 2.5i 4.5i
.ce 1
\\$1
..
.de CF		\" center a function on a line
.sp
.ce 1
\\$1
.sp
..
.TH extract-commands LOCAL "December 1992" "Xerion" "Xerion Manual"
.SH NAME
extract-commands - extract command functions from object files

.SH SYNOPSIS
extract-commands <output file> file1 [ file2 ... ]

.SH DESCRIPTION
The 
.BF extract-commands
command reads a series of object files and creates a C source code
file which can be used by the Xerion command line interface.  The
generated file contains code which will register functions from the
object files as commands callable from the Xerion command line
interface.

.BF extract-commands
uses the unix command 
.BF nm
to find in the object files all external functions whose names begin
with the string "command_". These functions are then registered as
commands.  E.g. the function "command_train" will be registered as
"train" and be callable as such from the Xerion command line.

Arrays of character strings whose names begin with the string
"helpString_" are registered as help strings or short descriptions to
accompany "whatis". E.g. the following declaration will cause the
string to be printed when "whatis readpath" is typed at the xerion
prompt.

.nf
char	*helpString_readpath[] = {
  "A list of space or colon separated directories to search",
  "for read-files.  This variable is used by all commands",
  "which take input from files.",
  NULL } ;
.fi

As well, 
.BF extract-commands
extracts all functions whose names begin with the string "autoinit_".
These functions are registered to be called during the initialization
of the simulator.

In order to perform the extraction
.BF extract-commands
uses two environment variables. These are
.BF NMCMD
which is the command to give Berkely style nm output (e.g. nm -B), and
.BF NMUNDERSCORE
which should be 1 if nm prepends an underscore to symbols, and 0 if
not.

.SH SEE ALSO
create-bindings(LOCAL)

.SH AUTHORS
The original version of extract-commands was written by Tony Plate
(tap@ai.toronto.edu). Since then it has been extensively revised by
Drew van Camp (drew@ai.toronto.edu).

\" Local Variables: *
\" mode:nroff *
\" End: *
